.\" DAL DaDbgFlag(3) manpage
.\"
.\"
.\" +============================================+
.\" |  Author:          Yury Georgievskiy, CERN  |
.\" |  Creation date:   08.05.2007               |
.\" +============================================+
.\"
.\"
.TH DADBGFLAG "3" "May 2007" "Driver Access Library" "DAL User's Manual"
.SH NAME
DaDbgFlag \- enable/disable/exploit driver and DAL flags
.SH SYNOPSIS
.B int DaDbgFlag(HANDLE \fIhandle\fB, int \fIflag\fB, REGOPTYPE \fIopt\fB);
.SH DESCRIPTION
Use this function to tune the driver and \fBDAL\fR behavior.
.\".TP
.IP \fIhandle
- is a library handle, returned by \fIDaEnableAccess()\fR call
.\".TP
.IP \fIflag
- these are possible toggling flags. They are defined in \fBda_dbg\fR for DAL and in \fBdbgIPL\fR for the driver.
.sp
\fIDriver debug flags \fBdbgIPL\fI enum type:
.TP
.B DBGINSTL
Trace driver installation procedure
.TP
.B DBGDEINSTL
Trace driver deinstallation procedure
.TP
.B DBGIOCTL
Trace driver ioctl calls
.TP
.B DBGTIMESTAT
Trace register access time statistics
.sp 2
\fIDAL debug flags \fBda_dbg\fI enum type:
.TP
.B DA_DBG_ERR_INFO
Printout DAL error information
.TP
.B DA_DBG_RW_OPS
Trace dma read/write operations
.IP \fIopt
- depend on the operation you want to perform should be one of the following:
.sp
.B OPRD \fR- read. Get current debug flags
.sp
.B OPWR \fR- write. Toggle choosen debug flags
.sp
.P
If you want to get current \fIdebugFlag\fR value (\fIopt\fR parameter is
\fBOPRD\fR), then \fIflag\fR parameter is ignored. If you want to toggle flags
(\fIopt\fR parameter is \fBOPWR\fR), you should indicate which flags you want
to toggle. So if toggled bit was on - it will be off afterwards, and vice
versa. In this case previous value of the \fIdebugFlag\fR is returned.
.SH RETURN VALUE
Depends on the performed operation:
.TP
If you want to toggle flags (\fIopt\fR is \fBOPWR\fR)
-
.B previous \fIdebugFlag\fB value
.TP
If you want to get current flags (\fIopt\fR is \fBOPRD\fR)
-
.B current \fIdebugFlag\fB value
.TP
In case of failure one of the following:
.TP
.B -DA_ERR_BAD_HANDLE
- user handle is bad
.TP
.B -DA_ERR_IOCTL_FAIL
 - can't get/set driver flags, because ioctl operation fails
.TP
.B -DA_ERR_INT_ERR
- wrong \fIflag\fR parameter
.TP
.B -DA_ERR_NOT_INIT
- library was not initialized, i.e. \fIDaEnableAccess()\fR was not called
.SH EXAMPLES
.TP
Toggle debug flags:
.ft B
#include <VMEinclude/DrvrAccess.h>

/* get DAL handle */
.br
HANDLE handle = DaEnableAccess(mod, access_mode, lun, chanN);
.sp
/* get current flag value */
.br
dbgIPL dflg = DaDbgFlag(handle, 0, OPRD);
.sp
/* choose flags to toggle */
.br
dflg |= (DBGINSTL | DBGDEINSTL);
.sp
/* do toggling */
.br
DaDbgFlag(handle, dflg, OPWR);
.SH NOTE
All the flags that you point out in the \fIflag\fR parameter will be toggled.
All the rest will remain untouched.
.SH AUTHOR
Written by Yury Georgievskiy <ygeorgie@gmail.com>
.SH SEE ALSO
.BR driverGen (8),
.BR modinst (8),
.BR moduninst (8),
.BR dal (3),
.BR DaEnableAccess (3),
.BR DaDisableAccess (3),
.BR DaSetDefAM (3),
.BR DaGetDefAM (3),
.BR DaGetNodeFd (3),
.BR DaGetRegister (3),
.BR DaGetRegChunk (3),
.BR DaSetRegister (3),
.BR DaSetRegChunk (3),
.BR DaGetRegDepth (3),
.BR DaGetRegSize (3),
.BR DaGetRegRep (3),
.BR DaSetRegRep (3),
.BR DaGetRegAccessRights (3),
.BR DaGetRegName (3),
.BR DaDrvrVers (3),
.BR DaLibVers (3),
.BR DaGetErrCode (3),
.BR DaUserEntryPoint (3)
